"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withRefs = exports.isEmpty = exports.isLoading = exports.simple = exports.loadingData = exports.simpleData = exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _Sidebar = _interopRequireDefault(require("./Sidebar"));

var _Heading = require("./Heading.stories");

var _mockdata = require("./mockdata");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _default = {
  component: _Sidebar["default"],
  title: 'UI/Sidebar/Sidebar',
  excludeStories: /.*Data$/
};
exports["default"] = _default;
var menu = _Heading.standardData.menu;
var stories = _mockdata.mockDataset.withRoot;
var storyId = '1-12-121';
var simpleData = {
  menu: menu,
  stories: stories,
  storyId: storyId
};
exports.simpleData = simpleData;
var loadingData = {
  menu: menu,
  stories: {}
};
exports.loadingData = loadingData;
var refs = {
  optimized: {
    id: 'optimized',
    title: 'This is a ref',
    url: 'https://example.com',
    ready: false,
    type: 'lazy',
    stories: stories
  }
};

var simple = function simple() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: true,
    menu: menu,
    stories: stories,
    storyId: storyId,
    refs: {}
  });
};

exports.simple = simple;
simple.displayName = "simple";

var isLoading = function isLoading() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: false,
    menu: menu,
    stories: {},
    isLoading: true,
    refs: {}
  });
};

exports.isLoading = isLoading;
isLoading.displayName = "isLoading";

var isEmpty = function isEmpty() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: true,
    menu: menu,
    stories: {},
    isLoading: true,
    refs: {}
  });
};

exports.isEmpty = isEmpty;
isEmpty.displayName = "isEmpty";

var withRefs = function withRefs() {
  return /*#__PURE__*/_react["default"].createElement(_Sidebar["default"], {
    storiesConfigured: true,
    menu: menu,
    stories: stories,
    isLoading: true,
    refs: refs
  });
};

exports.withRefs = withRefs;
withRefs.displayName = "withRefs";